/**********************************************************************
  oCit@CsR}h
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "funcs.h"
#include "processor.h"
#include "memory.h"
#include "op_exec.h"

int	op_fetch( struct MACHINE_RESOURCE *mres ) ;
int	op_exec1( struct MACHINE_RESOURCE *mres ) ;
int	exception( struct MACHINE_RESOURCE *mres , int code ) ;

int	exec_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
int	excp ;
int     id ;
int     res ;
int     ptr ;
int     i,cmdlen ;
int     arglen ;
int	break_flag ;
unsigned char *cmdptr, *cmdline ; 

 break_flag=ON ;
 id=proc_list.cur_id ;

 if( (mode & GO_EXEC_MODE)!=0 ){ //VKvZXforkĎs 
   res=create_proc( &proc_list, default_memsize ) ;
   if( res != NORMAL_EXIT ){
     fprintf(simmsgfp,"vZX̐Ɏs܂\n") ;
     return( res ) ;
   }
   id=proc_list.cur_id ;
   // res=sim_eload(  &proc_list.proc[id], tk_pt->pt[1] ) ;
   res=elf_load(  &proc_list.proc[id], tk_pt->pt[1] ) ;
   if( res != NORMAL_EXIT ){
     remove_proc( &proc_list ) ;
     return( res ) ;
   }
   
   sim_setarg( &proc_list.proc[id], tk_pt, 1 ) ;
   if( res != NORMAL_EXIT ){
     remove_proc( &proc_list ) ;
     return( res ) ;
   }
   
   iexe_count  = 0 ;
   iexe_count2 = 0 ;
   break_flag=OFF ;
 }
 // if( mode==1 ){ //u[N|CgݒŎ~܂ɎsĊJ
   
 set_sighandl_ppcsim() ;
 while ( -1 ) {
   if( sig_int != 0 ) break ;
   excp = op_fetch( &proc_list.proc[id] ) ;
   if( excp !=0 ){
     excp=exception( &proc_list.proc[id], (excp | OPFETCH_FLAG) ) ;
     if( excp!=0 ) break ;
   }

   trace_history[trace_ptr].pc   = proc_list.proc[id].pc ;
   trace_history[trace_ptr].inst = proc_list.proc[id].inst ;
   trace_ptr++ ;
   trace_ptr=trace_ptr%HISTORY_SIZE ;

   iexe_count++ ;
   if( iexe_count==0x80000000 ){
     iexe_count =0 ;
     iexe_count2++ ;
   }

   if( trace_stat!=TRACE_OFF ){
     fprintf(simmsgfp,"0x%08x inst=0x%08x\n",
	     proc_list.proc[id].pc,
	     proc_list.proc[id].inst) ;
     if( trace_stat==TRACE_GRP ){
       print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
     }
     if( trace_stat==TRACE_ALL ){
       print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
     }
   }
   
   if( proc_list.proc[id].bp_num > 0 ){
     for( i=0 ; i<proc_list.proc[id].bp_num ; i++ ){
       if( proc_list.proc[id].pc==proc_list.proc[id].break_pt[i] ){
	 if( break_flag==ON ){ //break|CgŎ~܂ĊJɂ܂Ȃlɂ
	   break ;
	 }else{
	   fprintf(simmsgfp,"Exec stop by break point.\n") ;
	   fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
		   proc_list.proc[id].pc,
		   proc_list.proc[id].inst) ;
	   return(NORMAL_EXIT) ;     
	 }
       }
     }
     break_flag=OFF ;
   }else{
     break_flag=OFF ;
   }

   if( proc_list.proc[id].pp_num > 0 ){
     for( i=0 ; i<proc_list.proc[id].pp_num ; i++ ){
       if( proc_list.proc[id].pc==proc_list.proc[id].pass_pt[i] ){
	 switch( pp_msg ){
	 case PP_DUMP_PC :
	   fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		   proc_list.proc[id].pc,
		   proc_list.proc[id].inst) ;
	   break ;
	 case PP_DUMP_GPR :
	   fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		   proc_list.proc[id].pc,
		   proc_list.proc[id].inst) ;
	   print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
	   break ;
	 case PP_DUMP_ALL :
	   fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		   proc_list.proc[id].pc,
		   proc_list.proc[id].inst) ;
	   print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
	   break ;
	 default :
	 }
	 break ;
       }
     }
   }

   excp = op_exec1( &proc_list.proc[id] ) ;
   sim_io( &proc_list.proc[id] ) ;

   if( excp !=0 ){
     switch( excp ){
     case SYSCALLED_EXIT :
       //fprintf(simmsgfp,"exit() was called. Simulation is stopped.\n") ;
       fprintf(simmsgfp,"called exit.\n") ;
       if( prof_stat==ON ){
	 fprintf(simmsgfp,"Number of executed instructions=") ;
	 if( iexe_count2>0 ){
	   fprintf(simmsgfp,"0x80000000*%d + %d\n",iexe_count2,iexe_count) ;
	 }else{
	   fprintf(simmsgfp,"%d\n",iexe_count) ;
	 }
       }
       remove_proc( &proc_list ) ;
       id=proc_list.cur_id ;
       if( id==0 ) return(NORMAL_EXIT) ;
       proc_list.proc[id].GPR[3].rl= 1 ;
       break ;
     case SYSCALLED_FORK :
       sim_fork( &proc_list ) ;
       id=proc_list.cur_id ;
       proc_list.proc[id].GPR[3].rl= 0 ;
       proc_list.proc[id].id       = id ;
       fprintf(simmsgfp,"forked process.\n") ;
       break ;
     case SYSCALLED_EXECVE :
       /** R}h̎荞 fBNgpX菜 **/
       cmdlen=strlen(&proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[3].rl)][lad(proc_list.proc[id].GPR[3].rl)]) ;
       cmdptr=NULL ;
       arglen=0 ;
       for( i=cmdlen-1 ; i>-1 ; i-- ){
	 cmdptr=&proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[3].rl+i)][lad(proc_list.proc[id].GPR[3].rl+i)] ;
	 if( *cmdptr=='/' ){
	   cmdptr++ ;
	   break ;
	 }
       }
       arglen+=strlen(cmdptr)+1 ;
       //fprintf(simmsgfp,"execve %s", cmdptr ) ;
       
       /** ̎荞 **/
       for( i=0 ; ; i+=4 ){
	 ptr =proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+0)][lad(proc_list.proc[id].GPR[4].rl+i+0)]*0x01000000 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+1)][lad(proc_list.proc[id].GPR[4].rl+i+1)]*0x00010000 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+2)][lad(proc_list.proc[id].GPR[4].rl+i+2)]*0x00000100 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+3)][lad(proc_list.proc[id].GPR[4].rl+i+3)]*0x00000001 ;
	 if( ptr==0x00000000 ) break ;
	 arglen+=strlen(&proc_list.proc[id].mem[seg(ptr)][lad(ptr)])+1 ;
	 //fprintf(simmsgfp," %s", &proc_list.proc[id].mem[ ptr ] ) ;
       }
       //fprintf(simmsgfp,"  : %d\n",arglen) ;
       
       cmdline=malloc(arglen+2) ;
       cmdline[0]='\0' ;
       strcat( cmdline, cmdptr ) ;
       strcat( cmdline, " " ) ;
       for( i=0,arglen=0 ; ; i+=4 ){ //Ȃ񂩏璷....(^_^;;;
	 ptr =proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+0)][lad(proc_list.proc[id].GPR[4].rl+i+0)]*0x01000000 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+1)][lad(proc_list.proc[id].GPR[4].rl+i+1)]*0x00010000 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+2)][lad(proc_list.proc[id].GPR[4].rl+i+2)]*0x00000100 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+3)][lad(proc_list.proc[id].GPR[4].rl+i+3)]*0x00000001 ;
	 if( ptr==0x00000000 ) break ;
	 strcat( cmdline, &proc_list.proc[id].mem[seg(ptr)][lad(ptr)] ) ;
	 strcat( cmdline, " " ) ;
       }
       get_token( cmdline , &token ) ;
       
       init_regs( &proc_list.proc[id] ) ;
       proc_list.proc[id].heap_top = default_heaptop ;
       proc_list.proc[id].heap_size= 0 ;
       proc_list.proc[id].pc       = default_exec_start ;
       proc_list.proc[id].GPR[1].rl= proc_list.proc[id].mem_size[0] - default_stack_top_offset ;

       // res=sim_eload(  &proc_list.proc[id], cmdptr ) ;
       res=elf_load(  &proc_list.proc[id], cmdptr ) ;
       if( res != NORMAL_EXIT ) return( res ) ;
       sim_setarg( &proc_list.proc[id], tk_pt, 0 ) ;
       if( res != NORMAL_EXIT ) return( res ) ;
       free( cmdline ) ;
       break ;

     default :
       excp=exception( &proc_list.proc[id], excp ) ;
       if( excp!=0 ) return(NORMAL_EXIT) ;
     }
   }
 }
 return(NORMAL_EXIT) ;
}


