/**********************************************************************
  DECWX^
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int	op_decrement( struct MACHINE_RESOURCE *mres )
{
  
  if( (TBL & 0xfffffff0)==0xfffffff0 ) TBU++ ; TBL+=16 ;
  
  if( (*mres->MSR & 0x00008000)==0x00008000 ){
    if( dec_excp_pending==YES ){
      dec_excp_pending=NO ;
      return( EXCEPTION_DEC ) ;
    }
    *mres->SPR[22] -= 16 ;
    if( (*mres->SPR[22] & 0xfffffff0)==0xfffffff0 ){
      return( EXCEPTION_DEC ) ;
    }
  }
  //  else{
  //    *mres->SPR[22] -= 1 ;
  //    if( *mres->SPR[22]==0xffffffff ){
  //      dec_excp_pending=YES ;
  //    }
  //  }
  return(0) ;
}

int	op_external_interrupt( struct MACHINE_RESOURCE *mres )
{
  if( (*mres->MSR & 0x00008000)!=0 ){
    RTC += 0x00000001 ;
    if( (RTC & 0x00fff000)==0x00800000 ){
      RTC=0 ;
      return( EXCEPTION_EE ) ;
    }
  }
  return(0) ;
}

int	op_single_step( struct MACHINE_RESOURCE *mres )
{
  if( (*mres->MSR & 0x00008000)!=0 && (*mres->MSR & 0x00000400)!=0 ){
      return( EXCEPTION_SE ) ;
  }
  return(0) ;
}

int	chk_single_step( struct MACHINE_RESOURCE *mres )
{
  if( (*mres->MSR & 0x00008000)!=0 && (*mres->MSR & 0x00000400)!=0 ){
      return( YES ) ;
  }
  return( NO ) ;
}
