/**********************************************************************
  V~[VXe[^X\
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

#define retstat(a) ((a==ENABLE)? "ENABLE" : (a==DISABLE) ? "DISABLE" : "UNDEFINED")

void print_simstat()
{
  fprintf(simmsgfp,"---Exception simulate status---\n") ;
  fprintf(simmsgfp,"0x0100(system_reset)               = %s\n", retstat(excp_stat.e0100.stat)) ;
  fprintf(simmsgfp,"0x0200(machine check)              = %s\n", retstat(excp_stat.e0200.stat)) ;
  fprintf(simmsgfp,"0x0300(data access)                = %s\n", retstat(excp_stat.e0300.stat)) ;
  fprintf(simmsgfp,"0x0400(instruction access)         = %s\n", retstat(excp_stat.e0400.stat)) ;
  fprintf(simmsgfp,"0x0500(external interrupt)         = %s\n", retstat(excp_stat.e0500.stat)) ;
  fprintf(simmsgfp,"0x0600(alignment)                  = %s\n", retstat(excp_stat.e0600.stat)) ;
  fprintf(simmsgfp,"0x0700(program)                    = %s\n", retstat(excp_stat.e0700.stat)) ;
  fprintf(simmsgfp,"0x0800(floating point unabailable) = %s\n", retstat(excp_stat.e0800.stat)) ;
  fprintf(simmsgfp,"0x0900(decrementer)                = %s\n", retstat(excp_stat.e0900.stat)) ;
  fprintf(simmsgfp,"0x0a00(??????)                     = %s\n", retstat(excp_stat.e0a00.stat)) ;
  fprintf(simmsgfp,"0x0c00(system call)                = %s\n", retstat(excp_stat.e0c00.stat)) ;
  fprintf(simmsgfp,"0x0d00(trace)                      = %s\n", retstat(excp_stat.e0d00.stat)) ;
  fprintf(simmsgfp,"0x0e00(floating point assist)      = %s\n", retstat(excp_stat.e0e00.stat)) ;
  fprintf(simmsgfp,"0x2f00(ppcsim : divided by zero )  = %s\n", retstat(excp_stat.e2f00.stat)) ;
}
